%define		qt_ver		4.8
%define		pyside_ver	1.2.4
#
# Conditional build:
%bcond_with	apidocs		# build API documentation (needs Qt sources)
%bcond_without	python2		# CPython 2.x module
%bcond_without	python3		# CPython 3.x module
%bcond_with	python3_default	# default to python3
#
Summary:	PySide - Python bindings for the Qt 4 toolkit
Summary(pl.UTF-8):	PySide - wiązania Pythona do toolkitu Qt 4
Name:		python-PySide
Version:	%{qt_ver}_%{pyside_ver}
Release:	1
License:	LGPL v2.1+
Group:		Libraries/Python
#Source0Download: https://github.com/pyside/PySide/releases
Source0:	https://github.com/pyside/PySide/archive/%{pyside_ver}/PySide-%{pyside_ver}.tar.gz
# Source0-md5:	c28563e1f3c3ce269a7cc634f97d271c
URL:		https://github.com/pyside/PySide/
BuildRequires:	OpenGL-devel
BuildRequires:	QtCore-devel >= %{qt_ver}
BuildRequires:	QtDeclarative-devel >= %{qt_ver}
BuildRequires:	QtGui-devel >= %{qt_ver}
BuildRequires:	QtHelp-devel >= %{qt_ver}
BuildRequires:	QtMultimedia-devel >= %{qt_ver}
BuildRequires:	QtNetwork-devel >= %{qt_ver}
BuildRequires:	QtOpenGL-devel >= %{qt_ver}
BuildRequires:	QtScript-devel >= %{qt_ver}
BuildRequires:	QtScriptTools-devel >= %{qt_ver}
BuildRequires:	QtSql-devel >= %{qt_ver}
BuildRequires:	QtSvg-devel >= %{qt_ver}
BuildRequires:	QtTest-devel >= %{qt_ver}
BuildRequires:	QtUiTools-devel >= %{qt_ver}
BuildRequires:	QtWebKit-devel >= %{qt_ver}
BuildRequires:	QtXml-devel >= %{qt_ver}
BuildRequires:	QtXmlPatterns-devel >= %{qt_ver}
BuildRequires:	cmake >= 2.6
BuildRequires:	phonon-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.605
%{?with_python2:BuildRequires:	shiboken-python2 >= %{pyside_ver}}
%{?with_python3:BuildRequires:	shiboken-python3 >= %{pyside_ver}}
%if %{with apidocs}
BuildRequires:	graphviz
BuildRequires:	qt4-build
BuildRequires:	qt4-source
BuildRequires:	sphinx-pdg
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		py3_soabi	%(%{__python3} -c 'import sysconfig; print(sysconfig.get_config_var("SOABI"));')

%description
PySide project provides LGPL-licensed Python bindings for the Qt. It
also includes complete toolchain for rapidly generating bindings for
any Qt-based C++ class hierarchies. PySide Qt bindings allow both free
open source and proprietary software development and ultimately aim to
support Qt platforms.

This package contains Python 2 bindings.

%description -l pl.UTF-8
Projekt PySide udostępnia na licencji LGPL wiązania Pythona dla
tookitu Qt. Zawiera także pełny zestaw narzędzi do szybkiego
generowania wiązań dla dowolnej hierarchii klas C++ opartych na Qt.
Wiązania Qt PySide pozwalają na tworzenie zarówno wolnodostępnego, jak
i własnościowego oprogramowania i mają na celu wsparcie platform Qt.

Ten pakiet zawiera wiązania Pythona 2.

%package devel
Summary:	Development files for PySide bindings
Summary(pl.UTF-8):	Pliki programistyczne dla wiązań PySide
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	shiboken-python2 >= %{pyside_ver}

%description devel
Development files for PySide bindings for Python 2.

%description devel -l pl.UTF-8
Pliki programistyczne dla wiązań PySide dla Pythona 2.

%package common-devel
Summary:	Common development files for PySide bindings
Summary(pl.UTF-8):	Wspólne pliki programistyczne dla wiązań PySide
Group:		Development/Libraries
Conflicts:	python-PySide-devel < 4.8_1.2.4-1

%description common-devel
Development files for PySide bindings, common for Python 2 and 3.

%description common-devel -l pl.UTF-8
Pliki programistyczne dla wiązań PySide, wspólne dla Pythona 2 i 3.

%package -n python3-PySide
Summary:	PySide - Python bindings for the Qt 4 toolkit
Summary(pl.UTF-8):	PySide - wiązania Pythona do toolkitu Qt 4
Group:		Libraries/Python

%description -n python3-PySide
PySide project provides LGPL-licensed Python bindings for the Qt. It
also includes complete toolchain for rapidly generating bindings for
any Qt-based C++ class hierarchies. PySide Qt bindings allow both free
open source and proprietary software development and ultimately aim to
support Qt platforms.

This package contains Python 3 bindings.

%description -n python3-PySide -l pl.UTF-8
Projekt PySide udostępnia na licencji LGPL wiązania Pythona dla
tookitu Qt. Zawiera także pełny zestaw narzędzi do szybkiego
generowania wiązań dla dowolnej hierarchii klas C++ opartych na Qt.
Wiązania Qt PySide pozwalają na tworzenie zarówno wolnodostępnego, jak
i własnościowego oprogramowania i mają na celu wsparcie platform Qt.

Ten pakiet zawiera wiązania Pythona 3.

%package -n python3-PySide-devel
Summary:	Development files for PySide bindings
Summary(pl.UTF-8):	Pliki programistyczne dla wiązań PySide
Group:		Development/Libraries
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	python3-PySide = %{version}-%{release}
Requires:	shiboken-python3 >= %{pyside_ver}

%description -n python3-PySide-devel
Development files for PySide bindings for Python 3.

%description -n python3-PySide-devel -l pl.UTF-8
Pliki programistyczne dla wiązań PySide dla Pythona 3.

%prep
%setup -q -n PySide-%{pyside_ver}

%build
%if %{with python2}
install -d build-py2
cd build-py2
%cmake .. \
	-DPYTHON_SUFFIX=-python%{py_ver}

%{__make}
cd ..
%endif

%if %{with python3}
install -d build-py3
cd build-py3
%cmake .. \
	-DPYTHON_SUFFIX=.%{py3_soabi}
%endif

%install
rm -rf $RPM_BUILD_ROOT

# version installed as last will be default (it covers default PYTHON_SUFFIX in cmake files and .pc symlink)
for pyver in %{?with_python3_default:%{?with_python2:py2}} %{?with_python3:py3} %{!?with_python3_default:%{?with_python2:py2}} ; do

%{__make} -C build-${pyver} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_pkgconfigdir}/pyside.pc $RPM_BUILD_ROOT%{_pkgconfigdir}/pyside-${pyver}.pc
ln -sf pyside-${pyver}.pc $RPM_BUILD_ROOT%{_pkgconfigdir}/pyside.pc

done

%if %{with python2}
%py_comp $RPM_BUILD_ROOT%{py_sitedir}/PySide
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}/PySide
%py_postclean
%endif

%if %{with python3}
%py3_comp $RPM_BUILD_ROOT%{py3_sitedir}/PySide
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitedir}/PySide
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%if %{with python2}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyside-python%{py_ver}.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpyside-python%{py_ver}.so.1.2
%dir %{py_sitedir}/PySide
%attr(755,root,root) %{py_sitedir}/PySide/QtCore.so
%attr(755,root,root) %{py_sitedir}/PySide/QtDeclarative.so
%attr(755,root,root) %{py_sitedir}/PySide/QtGui.so
%attr(755,root,root) %{py_sitedir}/PySide/QtHelp.so
%attr(755,root,root) %{py_sitedir}/PySide/QtMultimedia.so
%attr(755,root,root) %{py_sitedir}/PySide/QtNetwork.so
%attr(755,root,root) %{py_sitedir}/PySide/QtOpenGL.so
%attr(755,root,root) %{py_sitedir}/PySide/QtScript.so
%attr(755,root,root) %{py_sitedir}/PySide/QtScriptTools.so
%attr(755,root,root) %{py_sitedir}/PySide/QtSql.so
%attr(755,root,root) %{py_sitedir}/PySide/QtSvg.so
%attr(755,root,root) %{py_sitedir}/PySide/QtTest.so
%attr(755,root,root) %{py_sitedir}/PySide/QtUiTools.so
%attr(755,root,root) %{py_sitedir}/PySide/QtWebKit.so
%attr(755,root,root) %{py_sitedir}/PySide/QtXml.so
%attr(755,root,root) %{py_sitedir}/PySide/QtXmlPatterns.so
%attr(755,root,root) %{py_sitedir}/PySide/phonon.so
%{py_sitedir}/PySide/__init__.py[co]
%{py_sitedir}/PySide/_utils.py[co]

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyside-python%{py_ver}.so
%{_pkgconfigdir}/pyside-py2.pc
%{!?with_python3_default:%{_pkgconfigdir}/pyside.pc}
%{_libdir}/cmake/PySide-%{pyside_ver}/PySideConfig-python%{py_ver}.cmake
%endif

%files common-devel
%defattr(644,root,root,755)
%{_includedir}/PySide
%dir %{_datadir}/PySide
%{_datadir}/PySide/typesystems
%dir %{_libdir}/cmake/PySide-%{pyside_ver}
%{_libdir}/cmake/PySide-%{pyside_ver}/PySideConfig.cmake
%{_libdir}/cmake/PySide-%{pyside_ver}/PySideConfigVersion.cmake

%if %{with python3}
%files -n python3-PySide
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyside.%{py3_soabi}.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpyside.%{py3_soabi}.so.1.2
%dir %{py3_sitedir}/PySide
%attr(755,root,root) %{py3_sitedir}/PySide/QtCore.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtDeclarative.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtGui.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtHelp.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtMultimedia.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtNetwork.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtOpenGL.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtScript.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtScriptTools.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtSql.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtSvg.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtTest.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtUiTools.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtWebKit.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtXml.so
%attr(755,root,root) %{py3_sitedir}/PySide/QtXmlPatterns.so
%attr(755,root,root) %{py3_sitedir}/PySide/phonon.so
%{py3_sitedir}/PySide/__init__.py
%{py3_sitedir}/PySide/_utils.py
%{py3_sitedir}/PySide/__pycache__

%files -n python3-PySide-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyside.%{py3_soabi}.so
%{_pkgconfigdir}/pyside-py3.pc
%{?with_python3_default:%{_pkgconfigdir}/pyside.pc}
%{_libdir}/cmake/PySide-%{pyside_ver}/PySideConfig.%{py3_soabi}.cmake
%endif
%changelog
* Sat Apr 24 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-PySide.git;a=log;h=master

* Fri Apr 23 2021 Jakub Bogusz <qboosh@pld-linux.org> 6bbd1fa
- unified python2/python3 suffixes and default chosing with shiboken

* Fri Apr 23 2021 Jakub Bogusz <qboosh@pld-linux.org> 573a26d
- build also python3-* packages; common part of -devel in -common-devel, .pc files renamed to pyside-pyVER.pc

* Thu Apr 22 2021 Jakub Bogusz <qboosh@pld-linux.org> 6dd402f
- updated to PySide 1.2.4

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 6012e1f
- release 2 (by relup.sh)

* Sun Aug 31 2014 Jakub Bogusz <qboosh@pld-linux.org> cd9f4af
- updated to 1.2.2

* Tue Jul 09 2013 Jakub Bogusz <qboosh@pld-linux.org> 2d28a82
- new

